diff -urN microwindows-0.91/src/engine/devdraw.c microwindows-0.91.g100/src/engine/devdraw.c
--- microwindows-0.91/src/engine/devdraw.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/engine/devdraw.c	2007-06-16 17:10:27.000000000 +0200
@@ -22,6 +22,14 @@
 
 extern MWPIXELVAL gr_foreground;      /* current foreground color */
 extern MWPIXELVAL gr_background;      /* current background color */
+/*REM*/extern MWPIXELVAL gr_foreground_alpha;/* current foreground hardware independend alpha channel */
+/*REM*/extern MWPIXELVAL gr_background_alpha;/* current background hardware independend alpha channel */
+/*REM*/extern unsigned char* gr_alpha;       /* alpha channel*/
+/*REM*/extern unsigned char* gr_alpha_save;  /* save location for alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_x;         /* current x position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_y;         /* current y position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_width;     /* current width of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_height;    /* current height of alpha channel*/
 extern MWBOOL 	  gr_usebg;    	      /* TRUE if background drawn in pixmaps */
 extern int 	  gr_mode; 	      /* drawing mode */
 extern MWPALENTRY gr_palette[256];    /* current palette*/
@@ -39,6 +47,48 @@
 /*static*/ void drawrow(PSD psd,MWCOORD x1,MWCOORD x2,MWCOORD y);
 static void drawcol(PSD psd,MWCOORD x,MWCOORD y1,MWCOORD y2);
 
+/*REM: BEGIN*/
+/**
+ * Set current alpha channel
+ *
+ * @param alpha alpha channel.
+ * @param x         x pos of alpha channel.
+ * @param y         y pos of alpha channel.
+ * @param width     width of alpha channel.
+ * @param height    height of alpha channel.
+ */
+void
+GdSetAlphaChannel(unsigned char* alpha, MWCOORD x, MWCOORD y, MWCOORD width, MWCOORD height)
+{
+	gr_alpha = alpha;
+	gr_alpha_x = x;
+	gr_alpha_y = y;
+	gr_alpha_width  = width;
+	gr_alpha_height = height;
+}
+
+/**
+ * Save and hide  current alpha channel
+ */
+void
+GdSaveAlphaChannel()
+{
+        gr_alpha_save=gr_alpha;
+        gr_alpha=NULL;
+}
+
+/**
+ * Restore current alpha channel
+ */
+void
+GdRestoreAlphaChannel()
+{
+        gr_alpha=gr_alpha_save;
+        gr_alpha_save=NULL;
+}
+
+/*REM: END*/
+
 /**
  * Set the drawing mode for future calls.
  *
@@ -96,6 +146,12 @@
 	MWPIXELVAL oldfg = gr_foreground;
 
 	gr_foreground = fg;
+
+/*REM*/ #if (MWPIXEL_FORMAT == MWPF_TRUECOLOR8888) || (MWPIXEL_FORMAT == MWPF_TRUECOLOR0888)
+/*REM*/ gr_foreground_alpha = MWA(fg);
+/*REM*/ #else
+/*REM*/ gr_foreground_alpha = 0xff;//May be we have a FIXME here
+/*REM*/ #endif
 	return oldfg;
 }
 
@@ -112,6 +168,12 @@
 	MWPIXELVAL oldbg = gr_background;
 
 	gr_background = bg;
+/*REM*/ #if (MWPIXEL_FORMAT == MWPF_TRUECOLOR8888) || (MWPIXEL_FORMAT == MWPF_TRUECOLOR0888)
+/*REM*/ gr_background_alpha = MWA(bg);
+/*REM*/ #else
+/*REM*/ gr_background_alpha = 0xff;//May be we have a FIXME here
+/*REM*/ #endif
+
 	return oldbg;
 }
 
@@ -128,6 +190,7 @@
 	MWPIXELVAL oldfg = gr_foreground;
 
 	gr_foreground = GdFindColor(psd, fg);
+/*REM*/ gr_foreground_alpha = MWA(fg);
 	return oldfg;
 }
 
@@ -145,6 +208,7 @@
 	MWPIXELVAL oldbg = gr_background;
 
 	gr_background = GdFindColor(psd, bg);
+/*REM*/ gr_background_alpha = MWA(bg);
 	return oldbg;
 }
 
@@ -178,6 +242,10 @@
 GdPoint(PSD psd, MWCOORD x, MWCOORD y)
 {
 	if (GdClipPoint(psd, x, y)) {
+//*REM*/        firstly lets set the alpha value
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/         GdAlphaPixel(x,y,gr_foreground_alpha);
+/*REM*/#endif
 		psd->DrawPixel(psd, x, y, gr_foreground);
 		GdFixCursor(psd);
 	}
@@ -300,13 +368,20 @@
 			}
 
 			if (gr_dashcount) {
-				if ((gr_dashmask & (1 << bit)) && GdClipPoint(psd, x1, y1))
+			        if ((gr_dashmask & (1 << bit)) && GdClipPoint(psd, x1, y1)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x1,y1,gr_foreground_alpha);
+/*REM*/#endif
 					psd->DrawPixel(psd, x1, y1, gr_foreground);
-
+				}
 				bit = (bit + 1) % gr_dashcount;
 			} else {	/* No dashes */
-				if (GdClipPoint(psd, x1, y1))
+			        if (GdClipPoint(psd, x1, y1)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x1,y1,gr_foreground_alpha);
+/*REM*/#endif
 					psd->DrawPixel(psd, x1, y1, gr_foreground);
+				}
 			}
 
 			if (bDrawLastPoint && x1 == x2)
@@ -327,13 +402,21 @@
 
 			/* If we are trying to draw to a dash mask */
 			if (gr_dashcount) {
-				if ((gr_dashmask & (1 << bit)) && GdClipPoint(psd, x1, y1))
+           			if ((gr_dashmask & (1 << bit)) && GdClipPoint(psd, x1, y1)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x1,y1,gr_foreground_alpha);
+/*REM*/#endif
 					psd->DrawPixel(psd, x1, y1, gr_foreground);
+				}
 
 				bit = (bit + 1) % gr_dashcount;
 			} else {	/* No dashes */
-				if (GdClipPoint(psd, x1, y1))
+			        if (GdClipPoint(psd, x1, y1)) {
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x1,y1,gr_foreground_alpha);
+/*REM*/#endif
 					psd->DrawPixel(psd, x1, y1, gr_foreground);
+				}
 			}
 
 			if (bDrawLastPoint && y1 == y2)
@@ -348,7 +431,12 @@
 drawpoint(PSD psd, MWCOORD x, MWCOORD y)
 {
 	if (GdClipPoint(psd, x, y))
+	  {
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/         GdAlphaPixel(x,y,gr_foreground_alpha);
+/*REM*/#endif
 		psd->DrawPixel(psd, x, y, gr_foreground);
+	  }
 }
 
 /* Draw a horizontal line from x1 to and including x2 in the
@@ -381,6 +469,9 @@
 		while (x1 <= x2) {
 			if (GdClipPoint(psd, x1, y)) {
 				temp = MWMIN(clipmaxx, x2);
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                         GdAlphaHorzLine(x1,temp,y,gr_foreground_alpha);
+/*REM*/#endif
 				psd->DrawHorzLine(psd, x1, temp, y, gr_foreground);
 			} else
 				temp = MWMIN(clipmaxx, x2);
@@ -391,9 +482,12 @@
 
 		/* We want to draw a dashed line instead */
 		for (p = x1; p <= x2; p++) {
-			if ((gr_dashmask & (1 << bit)) && GdClipPoint(psd, p, y))
+		        if ((gr_dashmask & (1 << bit)) && GdClipPoint(psd, p, y)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                         GdAlphaPixel(p,y,gr_foreground_alpha);
+/*REM*/#endif
 				psd->DrawPixel(psd, p, y, gr_foreground);
-
+			}
 			bit = (bit + 1) % gr_dashcount;
 		}
 	}
@@ -427,6 +521,9 @@
 		while (y1 <= y2) {
 			if (GdClipPoint(psd, x, y1)) {
 				temp = MWMIN(clipmaxy, y2);
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                         GdAlphaVertLine(x,y1,temp,gr_foreground_alpha);
+/*REM*/#endif
 				psd->DrawVertLine(psd, x, y1, temp, gr_foreground);
 			} else
 				temp = MWMIN(clipmaxy, y2);
@@ -437,9 +534,12 @@
 
 		/* We want to draw a dashed line instead */
 		for (p = y1; p <= y2; p++) {
-			if ((gr_dashmask & (1<<bit)) && GdClipPoint(psd, x, p))
+		  if ((gr_dashmask & (1<<bit)) && GdClipPoint(psd, x, p)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                         GdAlphaPixel(x,p,gr_foreground_alpha);
+/*REM*/#endif
 				psd->DrawPixel(psd, x, p, gr_foreground);
-
+		  }
 			bit = (bit + 1) % gr_dashcount;
 		}
 	}
@@ -504,7 +604,7 @@
 	/* Stipples and tiles have their own drawing routines */
 	if (gr_fillmode != MWFILL_SOLID) {
 		set_ts_origin(x1, y1);
-
+		//*REM*/FIXME: Stripples and tiles does not support trans color
 		ts_fillrect(psd, x1, y1, width, height);
 		GdFixCursor(psd);
 		return;
@@ -515,6 +615,9 @@
 	 */
 	switch (GdClipArea(psd, x1, y1, x2, y2)) {
 	case CLIP_VISIBLE:
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/         GdAlphaFillRect(x1, y1, x2, y2, gr_foreground_alpha);
+/*REM*/#endif
 		psd->FillRect(psd, x1, y1, x2, y2, gr_foreground);
 		GdFixCursor(psd);
 		return;
@@ -523,7 +626,6 @@
 		return;
 	}
 
-
 	/* Quickly save off the dash settings to avoid problems with drawrow */
 	GdSetDash(&dm, &dc);
 
@@ -585,8 +687,12 @@
 			bitvalue = *imagebits++;
 		}
 		/* draw without clipping*/
-		if (MWIMAGE_TESTBIT(bitvalue))
+		if (MWIMAGE_TESTBIT(bitvalue)) {
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                 GdAlphaPixel(x,y,gr_foreground_alpha);
+/*REM*/#endif
 			psd->DrawPixel(psd, x, y, gr_foreground);
+		}
 		bitvalue = MWIMAGE_SHIFTBIT(bitvalue);
 		bitcount--;
 		if (x++ == maxx) {
@@ -639,10 +745,14 @@
 			bitcount = MWIMAGE_BITSPERIMAGE;
 			bitvalue = *imagebits++;
 		}
-		if (MWIMAGE_TESTBIT(bitvalue) && GdClipPoint(psd, x, y))
-			psd->DrawPixel(psd, x, y, gr_foreground);
-			bitvalue = MWIMAGE_SHIFTBIT(bitvalue);
-			bitcount--;
+		if (MWIMAGE_TESTBIT(bitvalue) && GdClipPoint(psd, x, y)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                 GdAlphaPixel(x,y,gr_foreground_alpha);
+/*REM*/#endif
+		        psd->DrawPixel(psd, x, y, gr_foreground);
+		}
+		        bitvalue = MWIMAGE_SHIFTBIT(bitvalue);
+		        bitcount--;
 		if (x++ == maxx) {
 			x = minx;
 			y++;
@@ -910,9 +1020,12 @@
 				break;
 			}
 
-			if (clip == CLIP_VISIBLE || GdClipPoint(psd, x, y))
+			if (clip == CLIP_VISIBLE || GdClipPoint(psd, x, y)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                         GdAlphaPixel(x,y,MWA(cr));
+/*REM*/#endif
 				psd->DrawPixel(psd, x, y, pixel);
-
+			}
 			if (x++ == maxx) {
 				/* printf("EOL\n  "); */
 				x = minx;
@@ -974,8 +1087,13 @@
 				}
 
 				if (clip == CLIP_VISIBLE
-				    || GdClipPoint(psd, x, y))
+				    || GdClipPoint(psd, x, y)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x,y,MWA(cr));
+/*REM*/#endif
+
 					psd->DrawPixel(psd, x, y, pixel);
+				}
 #if 0
 				/* fix: use clipmaxx to clip quicker */
 				else if (clip != CLIP_VISIBLE && !clipresult
@@ -1004,8 +1122,13 @@
 			default:
 			case 8:
 				bitcount = 0;
-				if (bitvalue == transcolor)
+				if (bitvalue == transcolor){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x,y,0x00);
+/*REM*/#endif
+
 					goto next;
+				}
 
 				pixel = convtable[bitvalue];
 				break;
@@ -1013,6 +1136,9 @@
 				if (((bitvalue & 0xf0) >> 4) == transcolor) {
 					bitvalue <<= 4;
 					bitcount -= 4;
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x,y,0x00);
+/*REM*/#endif
 					goto next;
 				}
 
@@ -1024,6 +1150,9 @@
 				--bitcount;
 				if (((bitvalue & 0x80) ? 1 : 0) == transcolor) {
 					bitvalue <<= 1;
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                                 GdAlphaPixel(x,y,0x00);
+/*REM*/#endif
 					goto next;
 				}
 
@@ -1032,8 +1161,13 @@
 				break;
 			}
 
-			if (clip == CLIP_VISIBLE || GdClipPoint(psd, x, y))
+			if (clip == CLIP_VISIBLE || GdClipPoint(psd, x, y)){
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/                         GdAlphaPixel(x,y,0xff);
+/*REM*/#endif
+
 				psd->DrawPixel(psd, x, y, pixel);
+			}
 #if 0
 			/* fix: use clipmaxx to clip quicker */
 			else if (clip != CLIP_VISIBLE && !clipresult
@@ -1541,8 +1675,10 @@
 		if (dstpsd != srcpsd)
 			GdCheckCursor(srcpsd, srcx, srcy, srcx+width-1,
 				srcy+height-1);
+
 		dstpsd->Blit(dstpsd, dstx, dsty, width, height,
 			srcpsd, srcx, srcy, rop);
+
 		GdFixCursor(dstpsd);
 		if (dstpsd != srcpsd)
 			GdFixCursor(srcpsd);
@@ -2340,3 +2476,133 @@
 		    outbuf += outpitch - width;
 	}
 }
+
+
+/*REM BEGIN: low level routines to draw into the hardware independent alpha channel*/
+void GdAlphaPixel(MWCOORD x, MWCOORD y,unsigned char alphaval)
+{
+  MWCOORD relx;
+  MWCOORD rely;
+
+  if(!gr_alpha) return;
+
+  relx=x-gr_alpha_x;
+  rely=y-gr_alpha_y;
+
+  if((relx>=0)&&(relx<gr_alpha_width)&&(rely>=0)&&(rely<gr_alpha_height))
+    gr_alpha[relx + (rely*gr_alpha_width)]=alphaval;
+}
+void GdAlphaFillRect(MWCOORD x1, MWCOORD y1, MWCOORD x2, MWCOORD y2, unsigned char alphaval)
+{
+  MWCOORD relx1,relx2;
+  MWCOORD rely1,rely2;
+
+  if(!gr_alpha) return;
+
+  relx1=x1-gr_alpha_x;
+  rely1=y1-gr_alpha_y;
+  relx2=x2-gr_alpha_x;
+  rely2=y2-gr_alpha_y;
+
+  //check if we can fill the whole area
+  if(((x2-x1+1)==gr_alpha_width) && ((y2-y1+1)==gr_alpha_height))
+    {
+      memset(gr_alpha,alphaval,gr_alpha_width*gr_alpha_height);
+      return;
+    }
+
+  if((relx1>=0)&&(relx2<gr_alpha_width)&&(rely1>=0)&&(rely2<gr_alpha_height))
+    {
+      int y;
+      for(y=rely1;y<=rely2;y++)
+	memset(&gr_alpha[(y*gr_alpha_width)+relx1],alphaval,(x2-x1)+1);
+    }
+}
+
+void GdAlphaHorzLine(MWCOORD x1, MWCOORD x2, MWCOORD y, unsigned char alphaval)
+{
+  MWCOORD relx1,relx2;
+  MWCOORD rely;
+
+  if(!gr_alpha) return;
+
+  relx1=x1-gr_alpha_x;
+  relx2=x2-gr_alpha_x;
+  rely =y-gr_alpha_y;
+  
+  if((relx1>=0)&&(relx2<gr_alpha_width)&&(rely>=0)&&(rely<gr_alpha_height))
+    memset(&gr_alpha[(rely*gr_alpha_width)+relx1],alphaval,(x2-x1)+1);
+
+}
+void GdAlphaVertLine(MWCOORD x, MWCOORD y1, MWCOORD y2, unsigned char alphaval)
+{
+  MWCOORD rely1,rely2;
+  MWCOORD relx;
+
+  if(!gr_alpha) return;
+
+  relx=x-gr_alpha_x;
+  rely1=y1-gr_alpha_y;
+  rely2=y2-gr_alpha_y;
+
+  if((relx>=0)&&(relx<gr_alpha_width)&&(rely1>=0)&&(rely2<gr_alpha_height))
+    {
+      int y;
+      for(y=rely1;y<=rely2;y++)
+	gr_alpha[(y*gr_alpha_width)+relx]=alphaval;
+    }
+}
+
+/*
+ * We copy a rectangle from srcalpha srcx,srcy srcwidth x scrheight to dstalpha, dstx, dsty 
+ * Be sure that src does fit into dst; dstheight and dstwith describes the dstalpha size
+ *
+ */
+void GdAlphaBlit(unsigned char *dstalpha, MWCOORD dstx, MWCOORD dsty, MWCOORD dstwidth, MWCOORD dstheight,
+		 unsigned char *srcalpha, MWCOORD srcx, MWCOORD srcy, MWCOORD srcwidth, MWCOORD srcheight)
+
+{
+  if(!dstalpha) return;
+  if(!srcalpha) return;
+  if(srcx>=srcwidth) return;
+  if(srcy>=srcheight) return;
+  if(srcwidth<=0) return;
+  if(srcheight<=0) return;
+
+  if(dstx>=dstwidth) return;
+  if(dsty>=dstheight) return;
+  if(dstwidth<=0) return;
+  if(dstheight<=0) return;
+
+  //FIXME:do a proper adjustment here; Currently we return here if src does not fit into dst
+  if(srcx<0) return;
+  if(srcy<0) return;
+  if(dstx<0) return;
+  if(dsty<0) return;
+  if((dstx+srcwidth)>dstwidth)return;
+  if((dsty+srcheight)>dstheight)return;
+
+  //printf("performoing GdAlphaBlit\n");
+
+  if(!srcx && !srcy && !dstx && !dsty && (dstheight==srcheight) && (dstwidth==srcwidth))
+    {
+      memcpy(dstalpha,srcalpha,srcwidth*srcheight);
+    }
+  else
+    {
+      unsigned char *dst=dstalpha+dstx;
+      unsigned char *src=srcalpha+srcx;
+      MWCOORD line=0;
+
+      while(line<srcheight)
+	{
+	  memcpy(dst,src,srcwidth);
+	  src+=srcwidth;
+	  dst+=dstwidth;
+	  line++;
+	}
+    }
+}
+
+
+/*REM END:*/
diff -urN microwindows-0.91/src/engine/devmouse.c microwindows-0.91.g100/src/engine/devmouse.c
--- microwindows-0.91/src/engine/devmouse.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/engine/devmouse.c	2006-10-12 18:23:44.000000000 +0200
@@ -404,6 +404,15 @@
 	cursorptr = cursorcolor;
 	maskptr = cursormask;
 
+
+/*REM*/#if defined(TRANS_COLOR)
+	//*REM*/Since cursor shouldnt be clipped out
+	//*REM*/by the clipmap,we simply hide it for some time 
+	//*REM*/We hide alpha channel, too.
+	/*REM*/GdSaveClipMap();
+        /*REM*/GdSaveAlphaChannel();
+/*REM*/#endif
+
 	/*
 	 * Loop through bits, resetting to firstbit at end of each row
 	 */
@@ -435,6 +444,10 @@
 	}
 
 	gr_mode = oldmode;
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/GdRestoreClipMap();
+        /*REM*/GdRestoreAlphaChannel();
+/*REM*/#endif
 	return prevcursor;
 }
 
@@ -454,6 +467,15 @@
 
 	if(curvisible-- <= 0)
 		return prevcursor;
+
+/*REM*/#if defined(TRANS_COLOR)
+	//*REM*/Since cursor shouldnt be clipped out
+	//*REM*/by the clipmap,we simply hide it for some time.
+	//*REM*/We hide alpha channel, too.
+	/*REM*/GdSaveClipMap();
+        /*REM*/GdSaveAlphaChannel();
+/*REM*/#endif
+
 	oldmode = gr_mode;
 	gr_mode = MWMODE_COPY;
 
@@ -467,6 +489,10 @@
 		}
 	}
  	gr_mode = oldmode;
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/GdRestoreClipMap();
+        /*REM*/GdRestoreAlphaChannel();
+/*REM*/#endif
 	return prevcursor;
 }
 
diff -urN microwindows-0.91/src/engine/devopen.c microwindows-0.91.g100/src/engine/devopen.c
--- microwindows-0.91/src/engine/devopen.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/engine/devopen.c	2006-10-12 18:23:44.000000000 +0200
@@ -34,6 +34,15 @@
 
        MWPIXELVAL gr_foreground;      /* current foreground color */
        MWPIXELVAL gr_background;      /* current background color */
+/*REM*/MWPIXELVAL gr_foreground_alpha;/* current foreground hardware independend alpha channel */
+/*REM*/MWPIXELVAL gr_background_alpha;/* current background hardware independend alpha channel */
+/*REM*/unsigned char* gr_alpha=NULL;  /* current alpha channel*/
+/*REM*/unsigned char* gr_alpha_save;  /* save location for alpha channel*/
+/*REM*/MWCOORD    gr_alpha_x;         /* current x position of alpha channel*/
+/*REM*/MWCOORD    gr_alpha_y;         /* current y position of alpha channel*/
+/*REM*/MWCOORD    gr_alpha_width;     /* current width of alpha channel*/
+/*REM*/MWCOORD    gr_alpha_height;    /* current height of alpha channel*/
+
        MWBOOL 	gr_usebg;    	    /* TRUE if background drawn in pixmaps */
        int 	gr_mode = MWMODE_COPY; 	    /* drawing mode */
 /*static*/ MWPALENTRY	gr_palette[256];    /* current palette*/
@@ -160,7 +169,7 @@
 #endif /* NOFONTSORCLIPPING*/
 
 	/* fill black (actually fill to first palette entry or truecolor 0*/
-	psd->FillRect(psd, 0, 0, psd->xvirtres-1, psd->yvirtres-1, 0);
+	psd->FillRect(psd, 0, 0, psd->xvirtres-1, psd->yvirtres-1, /*REM*//*0*/MWRGB(0,0,0));
 	return psd;
 }
 
diff -urN microwindows-0.91/src/include/device.h microwindows-0.91.g100/src/include/device.h
--- microwindows-0.91/src/include/device.h	2007-06-17 21:56:39.000000000 +0200
+++ microwindows-0.91.g100/src/include/device.h	2007-06-09 12:21:08.000000000 +0200
@@ -420,6 +420,15 @@
 	MWCOORD 	height;		/* height of rectangle */
 } MWCLIPRECT;
 
+/*REM BEGIN*/
+/* static clipmap with rectangle: drawing allowed if point within rectangle is marked as 0xff in clipmap*/
+typedef struct {
+  MWRECT *clipregion;
+  char *clipmap;
+  char dirty; /*1 if clipmap has at least one '0'; fb drivers will ignore clipmap if 0 is set*/
+} MWCLIPMAP;
+/*REM END*/
+
 typedef struct {
 	MWCOORD	width;
 	MWCOORD	height;
@@ -708,6 +717,17 @@
 int	GdCaptureScreen(char *path);
 void	GdGetScreenInfo(PSD psd,PMWSCREENINFO psi);
 void	GdPoint(PSD psd,MWCOORD x, MWCOORD y);
+/*REM: BEGIN*/
+void GdSetAlphaChannel(unsigned char* alpha, MWCOORD x, MWCOORD y, MWCOORD width, MWCOORD height);
+void GdSaveAlphaChannel();
+void GdRestoreAlphaChannel();
+void GdAlphaPixel(MWCOORD x, MWCOORD y,unsigned char alphaval);
+void GdAlphaFillRect(MWCOORD x1, MWCOORD y1, MWCOORD x2, MWCOORD y2, unsigned char alphaval);
+void GdAlphaHorzLine(MWCOORD x1, MWCOORD x2, MWCOORD y, unsigned char alphaval);
+void GdAlphaVertLine(MWCOORD x, MWCOORD y1, MWCOORD y2, unsigned char alphaval);
+void GdAlphaBlit(unsigned char *dstalpha, MWCOORD dstx, MWCOORD dsty, MWCOORD dstwidth, MWCOORD dstheight,
+		 unsigned char *srcalpha, MWCOORD srcx, MWCOORD srcy, MWCOORD srcwidth, MWCOORD srcheight);
+/*REM: END*/
 void	GdLine(PSD psd,MWCOORD x1,MWCOORD y1,MWCOORD x2,MWCOORD y2,
 		MWBOOL bDrawLastPoint);
 void	GdRect(PSD psd,MWCOORD x, MWCOORD y, MWCOORD width, MWCOORD height);
@@ -791,6 +811,16 @@
 
 /* devclip2.c*/
 void	GdSetClipRegion(PSD psd, MWCLIPREGION *reg);
+/*REM BEGIN*/
+void GdSetClipMap(MWCLIPMAP *clipm);
+void GdSaveClipMap();
+void GdRestoreClipMap();
+void GdDestroyClipMap(MWCLIPMAP *clipmap);
+MWCLIPMAP *GdAllocClipMap(MWCOORD minx,MWCOORD miny,MWCOORD maxx,MWCOORD maxy,unsigned char initval);
+MWCLIPMAP *GdGetClipMap();
+MWCLIPREGION *GdGetClipRegion();
+/*REM END*/
+
 
 /* devrgn.c - multi-rectangle region entry points*/
 MWBOOL GdPtInRegion(MWCLIPREGION *rgn, MWCOORD x, MWCOORD y);
diff -urN microwindows-0.91/src/include/mwtypes.h microwindows-0.91.g100/src/include/mwtypes.h
--- microwindows-0.91/src/include/mwtypes.h	2007-06-17 21:56:39.000000000 +0200
+++ microwindows-0.91.g100/src/include/mwtypes.h	2006-10-12 18:23:49.000000000 +0200
@@ -112,6 +112,10 @@
 #define MWRGB(r,g,b)	MWARGB(255,(r),(g),(b))		/* rgb full alpha*/
 #define MW0RGB(r,g,b)	MWARGB(0,(r),(g),(b))		/* rgb no alpha*/
 
+/*REM*/#define MWA(val) ((((MWCOLORVAL)val)&0xff000000)>>24)
+/*REM*/#define MWR(val) ((((MWCOLORVAL)val)&0x000000ff)>>0)
+/*REM*/#define MWG(val) ((((MWCOLORVAL)val)&0x0000ff00)>>8)
+/*REM*/#define MWB(val) ((((MWCOLORVAL)val)&0x00ff0000)>>16)
 
 /* convert an MWROP to drawing mode MWMODE value*/
 #define MWROP_TO_MODE(op)	((op) >> 24)
diff -urN microwindows-0.91/src/include/nano-X.h microwindows-0.91.g100/src/include/nano-X.h
--- microwindows-0.91/src/include/nano-X.h	2007-06-17 21:56:39.000000000 +0200
+++ microwindows-0.91.g100/src/include/nano-X.h	2007-06-03 18:20:41.000000000 +0200
@@ -104,6 +104,15 @@
 
 #define GR_MODE_DRAWMASK	0x00FF
 #define GR_MODE_EXCLUDECHILDREN	0x0100		/* exclude children on clip*/
+/*REM*/#define GR_MODE_DIRECTCHILD	0x0200	/* direct child only on clip (using GsSetClipWindowPart) */
+/*REM*/#define GR_MODE_DIRECTSIBLING	0x0400	/* direct sibling only on clip (using GsSetClipWindowPart)*/
+/*REM*/#define GR_MODE_THISWP	        0x0800	/* add wp to clipregion and clipmap on clip (using GsSetClipWindowPart)*/
+
+//*REM*/Flags for GsWpClearWpAndChilds
+/*REM*/#define GR_MODE_WPCLEAR_WP2CLR   0x0001  /* Tells GsWpClearWpAndChilds that wp is the window to be cleared*/
+/*REM*/#define GR_MODE_WPCLEAR_PARENT   0x0002  /* Tells GsWpClearWpAndChilds that we went up to next parent     */
+/*REM*/#define GR_MODE_WPCLEAR_SIBLING  0x0004  /* Tells GsWpClearWpAndChilds that we went to the next sibling   */
+/*REM*/#define GR_MODE_WPCLEAR_CHILD    0x0010  /* Tells GsWpClearWpAndChilds that we went to the next child     */
 
 /* Line modes */
 #define GR_LINE_SOLID           MWLINE_SOLID
@@ -726,6 +735,7 @@
 			GR_SIZE width, GR_SIZE height, GR_SIZE bordersize,
 			GR_COLOR background, GR_COLOR bordercolor);
 GR_WINDOW_ID    GrNewPixmap(GR_SIZE width, GR_SIZE height, void *pixels);
+/*REM*/GR_WINDOW_ID    GrResizePixmap(GR_WINDOW_ID wid,GR_SIZE width, GR_SIZE height, void * pixels);
 GR_WINDOW_ID	GrNewInputWindow(GR_WINDOW_ID parent, GR_COORD x, GR_COORD y,
 				GR_SIZE width, GR_SIZE height);
 void		GrDestroyWindow(GR_WINDOW_ID wid);
diff -urN microwindows-0.91/src/Makefile.rules microwindows-0.91.g100/src/Makefile.rules
--- microwindows-0.91/src/Makefile.rules	2007-06-17 21:56:35.000000000 +0200
+++ microwindows-0.91.g100/src/Makefile.rules	2006-10-12 18:23:41.000000000 +0200
@@ -62,6 +62,15 @@
 ifeq ($(ARCH),CYGWIN)
 INCLUDEDIRS += -I/usr/X11R6/include
 endif
+# REM: BEGIN: custom keyboard device if no X11
+else
+ifneq ($(KEYBOARDDEV),"")
+DEFINES += -DKEYBOARDDEV="\"$(KEYBOARDDEV)"\"
+endif
+ifneq ($(MOUSEDEV),"")
+DEFINES += -DMOUSEDEV="\"$(MOUSEDEV)"\"
+endif
+# REM: END
 endif
 
 ifeq ($(VGALIB), Y)
@@ -230,6 +239,19 @@
 #LDFLAGS += -lpthread
 endif
 
+# REM: BEGIN: TCPIP support
+ifeq ($(HAVE_TCP_IP_SUPPORT), Y)
+DEFINES += -DHAVE_TCP_IP_SUPPORT=1
+endif
+# REM: END
+
+# REM: BEGIN: transparent color support
+ifeq ($(HAVE_TRANS_COLOR_SUPPORT), Y)
+DEFINES += -DTRANS_COLOR=1
+endif
+# REM: END
+
+
 # Driver-specific stuff
 ifneq ($(ARCH), ELKS)
 ifneq ($(ARCH), DJGPP)
diff -urN microwindows-0.91/src/nanox/client.c microwindows-0.91.g100/src/nanox/client.c
--- microwindows-0.91/src/nanox/client.c	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/client.c	2006-10-12 18:23:49.000000000 +0200
@@ -29,6 +29,13 @@
 #include <signal.h>
 #include <errno.h>
 #include <time.h>
+/*REM: BEGIN*/
+#ifdef HAVE_TCP_IP_SUPPORT
+#include <netinet/in.h>
+#include <netdb.h>
+#endif
+/*REM: END*/
+
 #if HAVE_SHAREDMEM_SUPPORT
 #include <sys/types.h>
 #include <sys/ipc.h>
@@ -68,8 +75,16 @@
  * Default to unix socket for client/server.
  * @internal
  */
+
+/*REM: BEGIN*/
+#ifdef HAVE_TCP_IP_SUPPORT
+#define ADDR_FAM AF_INET
+#else
 #define ADDR_FAM AF_UNIX
 #endif
+//#define ADDR_FAM AF_UNIX
+/*REM: END*/
+#endif //ADDR_FAM
 
 #define GR_CLOSE_FIX	1	/* dirty hack attempts to fix GrClose hang bug*/
 
@@ -317,15 +332,32 @@
 	struct sockaddr_in name;
 	struct hostent *he;
 	/* allow specification of remote nano-X server address*/
-	char *sockaddr = getenv("NXDISPLAY");
-	if (!sockaddr)
-		sockaddr = "127.0.0.1";		/* loopback address*/
+/*REM: BEGIN*/
+	char sockaddr[20]={0};
+	if(getenv("NXDISPLAY"))
+		strcpy(sockaddr,getenv("NXDISPLAY"));
+	else 
+		strcpy(sockaddr,"127.0.0.1");		/* loopback address*/
+
+	//char *sockaddr = getenv("NXDISPLAY");
+	//if (!sockaddr)
+	//	sockaddr = "127.0.0.1";		/* loopback address*/
+/*REM: END*/
+
 #elif ADDR_FAM == AF_UNIX
 	struct sockaddr_un name;
 	/* allow override of named UNIX socket (default /tmp/.nano-X)*/
-	char *sockname = getenv("NXDISPLAY");
-	if (!sockname)
-		sockname = GR_NAMED_SOCKET;
+/*REM: BEGIN*/
+	char sockname[20]={0};
+	if (getenv("NXDISLAY")!=NULL)
+		strcpy(sockname,getenv("NXDISPLAY"));
+	else
+		strcpy(sockname,GR_NAMED_SOCKET);
+
+	//char *sockname = getenv("NXDISPLAY");
+	//if (!sockname)
+	//	sockname = GR_NAMED_SOCKET;
+/*REM: END*/
 #else
 #error "ADDR_FAM not defined to AF_NANO, AF_INET or AF_UNIX"
 #endif
@@ -2043,6 +2075,33 @@
 	UNLOCK(&nxGlobalLock);
 }
 
+/*REM BEGIN:*/ 
+/**
+ * Resizes the specified Pixmap to be the specified width and height.
+ *
+ * @param wid  the ID of the Pixmap to resize
+ * @param width  the width to resize the window to
+ * @param height  the height to resize the window to
+ *
+ * @ingroup nanox_window
+ */
+GR_WINDOW_ID 
+GrResizePixmap(GR_WINDOW_ID wid, GR_SIZE width, GR_SIZE height, void * pixels)
+{
+	nxResizePixmapReq *req;
+
+	LOCK(&nxGlobalLock);
+	req = AllocReq(ResizePixmap);
+	req->windowid = wid;
+	req->width = width;
+	req->height = height;
+	if(TypedReadBlock(&wid, sizeof(wid), GrNumResizePixmap) == -1)
+		wid = 0;
+	UNLOCK(&nxGlobalLock);
+	return wid;
+}
+/*REM END*/ 
+
 /**
  * Changes the parent window of the specified window to the specified parent
  * window and places it at the specified coordinates relative to the new
diff -urN microwindows-0.91/src/nanox/nxproto.h microwindows-0.91.g100/src/nanox/nxproto.h
--- microwindows-0.91/src/nanox/nxproto.h	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/nxproto.h	2006-10-12 18:23:49.000000000 +0200
@@ -1366,4 +1366,17 @@
 	INT16 height;
 } nxCopyFontReq;
 
-#define GrTotalNumCalls         125
+/*REM BEGIN:*/
+#define GrNumResizePixmap          125
+typedef struct {
+	BYTE8	reqType;
+	BYTE8	hilength;
+	UINT16	length;
+	IDTYPE	windowid;
+	INT16	width;
+	INT16	height;
+/* FIXME: Add support for passing shared memory info */
+} nxResizePixmapReq;
+/*REM END*/
+
+/*REM*/ #define GrTotalNumCalls         126
diff -urN microwindows-0.91/src/nanox/serv.h microwindows-0.91.g100/src/nanox/serv.h
--- microwindows-0.91/src/nanox/serv.h	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/serv.h	2007-06-09 11:18:39.000000000 +0200
@@ -365,6 +365,11 @@
 	GR_WM_PROPS	props;		/* window properties*/
 	GR_CHAR		*title;		/* window title*/
 	MWCLIPREGION	*clipregion;	/* window clipping region */
+/*REM*/ unsigned char   *alpha;         /* alpha channel of window.*/
+                                        /* 0 means pixel is transparent and will*/ 
+                                        /* not be drawn. 255 pixel will be drawn.*/ 
+                                        /* An additional pixel based clipping region*/ 
+                                        /* will be generated with this information.*/ 
 };
 
 /*
@@ -382,6 +387,11 @@
 
 	GR_PIXMAP	*next;		/* next pixmap in list */
 	GR_CLIENT	*owner;		/* client that created it */
+/*REM*/ unsigned char   *alpha;         /* alpha channel of window.*/
+                                        /* 0 means pixel is transparent and will*/ 
+                                        /* not be drawn. 255 pixel will be drawn.*/ 
+                                        /* An additional pixel based clipping region*/ 
+                                        /* will be generated with this information.*/ 
 };
 
 /**
@@ -432,13 +442,32 @@
 			GR_COORD x, GR_COORD y, GR_SIZE width, GR_SIZE height);
 void		GsWpClearWindow(GR_WINDOW *wp, GR_COORD x, GR_COORD y,
 			GR_SIZE width, GR_SIZE height, GR_BOOL exposeflag);
-void		GsWpUnrealizeWindow(GR_WINDOW *wp, GR_BOOL temp_unmap);
+/*REM*/void     GsWpClearWindowUpAndDown(GR_WINDOW *wp, GR_COORD x, GR_COORD y, GR_SIZE width,
+					 GR_SIZE  height, GR_BOOL exposeflag);
+/*REM*/void     GsWpSmartClearWindow(GR_WINDOW *wp, MWRECT AreaToDraw, GR_BOOL exposeflag);
+/*REM*/void     GsWpClearWpAndChilds(GR_WINDOW *wp, MWRECT AreaToDraw, GR_BOOL exposeflag, int flags);
+void		GsWpUnrealizeWindow(GR_WINDOW *wp, GR_BOOL temp_unmap,/*REM*/char DoNotClear);
 void		GsWpRealizeWindow(GR_WINDOW *wp, GR_BOOL temp);
 void		GsWpDestroyWindow(GR_WINDOW *wp);
 void		GsSetPortraitMode(int mode);
 void		GsSetPortraitModeFromXY(GR_COORD rootx, GR_COORD rooty);
 void		GsSetClipWindow(GR_WINDOW *wp, MWCLIPREGION *userregion,
-			int flags);
+				int flags/*REM*/, MWRECT* RToClip);
+
+/*REM*/void	GsSetClipWindowPart(GR_WINDOW *wp, MWCLIPREGION *userregion,
+				int flags/*REM*/, MWRECT* RToClip);
+
+/*REM*/void     GsClipPixmap( char* vismap,
+			      GR_COORD	vismap_x,
+			      GR_COORD	vismap_y,
+			      GR_COORD	vismap_width,
+			      GR_COORD	vismap_height,
+			      char*        pixmap, 
+			      GR_COORD	pixmap_x,
+			      GR_COORD	pixmap_y,
+			      GR_COORD	pixmap_width,
+			      GR_COORD	pixmap_height);
+
 void		GsHandleMouseStatus(GR_COORD newx, GR_COORD newy,
 			int newbuttons);
 void		GsFreePositionEvent(GR_CLIENT *client, GR_WINDOW_ID wid,
@@ -478,7 +507,7 @@
 void		GsCheckMouseWindow(void);
 void		GsCheckFocusWindow(void);
 GR_DRAW_TYPE	GsPrepareDrawing(GR_DRAW_ID id, GR_GC_ID gcid,
-			GR_DRAWABLE **retdp);
+				 GR_DRAWABLE **retdp,/*REM*/MWRECT *AreaToDraw);
 GR_BOOL		GsCheckOverlap(GR_WINDOW *topwp, GR_WINDOW *botwp);
 GR_EVENT	*GsAllocEvent(GR_CLIENT *client);
 GR_WINDOW	*GsFindWindow(GR_WINDOW_ID id);
